Imports System.Xml.Serialization

<Serializable()> _
Public Class Person
    <XmlAttributeAttribute("GivenName")> _
    Public FirstName As String

    <XmlAttributeAttribute("FamilyName")> _
    Public LastName As String

    <XmlElement("StreetAddress")> _
    Public Street As String

    Public Enum ContactMethods
        <XmlEnum("SnailMail")> _
        Post
        <XmlEnum("Telephone")> _
        Phone
        <XmlEnum("Email")> _
        Email
    End Enum
    <XmlElement("ContactMethod")> _
    Public PreferredMethod As ContactMethods

    Public City As String
    Public State As String

    <XmlIgnore()> _
    Public Zip As String

    <XmlArray("PhoneNumbers"), XmlArrayItem("PhoneNum")> _
    Public Phones(1) As String

    <XmlArray("EmailAddresses")> _
    Public Emails(1) As String

    ' Empty constructor required for serialization.
    Public Sub New()
    End Sub

    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_Street As String, ByVal new_City As String, ByVal new_State As String, ByVal new_Zip As String, ByVal phone1 As String, ByVal phone2 As String, ByVal email1 As String, ByVal email2 As String, ByVal contact_method As ContactMethods)
        FirstName = new_FirstName
        LastName = new_LastName
        Street = new_Street
        City = new_City
        State = new_State
        Zip = new_Zip
        Phones = New String() {phone1, phone2}
        Emails = New String() {email1, email2}
        PreferredMethod = contact_method
    End Sub
End Class
